module Gdas::Context
  module Account
    extend ::ActiveSupport::Concern

    included do
      set_callback :invoke, :around, :load_account

      attr_reader :ch_account, :ch_account_id, :customer_id

      delegate :is_govcloud, :region_collection_override, to: :ch_account

      def load_account
        @ch_account_id = @options[:ch_account_id].to_i
        ::Logging.mdc.context['ch_account_id'] = @ch_account_id
        raise ::Platform::AccountNotFoundError, @options if @ch_account_id.zero?

        @ch_account = self.class.account_model.where(customer_id: @customer_id).find(@ch_account_id)

        yield
      rescue ::ActiveRecord::RecordNotFound
        raise ::Platform::AccountNotFoundError, @options
      ensure
        ::Logging.mdc.context&.delete 'ch_account_id'
      end
    end
  end
end
