# This file contains elements of cht_shared/lib/cht_shared/ec2_os.rb
module Gdas
  module Helpers
    module Ec2Os
      include ::Gdas::Constants::Ec2Os
      extend ::ActiveSupport::Concern

      included do
        def get_os_by_product(product_name)
          PRODUCT_TO_OS_MAP.each do |k, v|
            return v if product_name.match(k)
          end
          nil
        end

        def get_os_by_operation(operation_name)
          RE_OPERATION_TO_OS_MAP.each do |k, v|
            return v if operation_name =~ k
          end
          nil
        end
      end
    end
  end
end
