# This file contains elements of cp-analysis/lib/cp-analysis/dimensions/rds_engine_dimension.rb
module Gdas
  module Helpers
    module RdsUtils
      extend ::ActiveSupport::Concern

      included do
        MYSQL = 'mysql'
        POSTGRESQL = 'postgresql'
        ORACLE_SE = 'oracle-se'
        ORACLE_SE1 = 'oracle-se1'
        ORACLE_SE2 = 'oracle-se2'
        ORACLE_EE = 'oracle-ee'
        SQLSERVER_SE = 'sqlserver-se'
        SQLSERVER_EE = 'sqlserver-ee'
        SQLSERVER_EX = 'sqlserver-ex'
        SQLSERVER_WEB = 'sqlserver-web'
        MARIADB = 'mariadb'
        AURORA = 'aurora'
        AURORA_POSTGRESQL = 'aurora-postgresql'
        NEPTUNE = 'neptune'

        OPERATION_MAP = {
          'CreateDBInstance:0002' => { engine: MYSQL, license: 'none' },
          'CreateDBInstance:0003' => { engine: ORACLE_SE1, license: 'byol' },
          'CreateDBInstance:0004' => { engine: ORACLE_SE, license: 'byol' },
          'CreateDBInstance:0005' => { engine: ORACLE_EE, license: 'byol' },
          'CreateDBInstance:0006' => { engine: ORACLE_SE1, license: 'li' },
          'CreateDBInstance:0008' => { engine: SQLSERVER_SE, license: 'byol' },
          'CreateDBInstance:0009' => { engine: SQLSERVER_EE, license: 'byol' },
          'CreateDBInstance:0010' => { engine: SQLSERVER_EX, license: 'li' },
          'CreateDBInstance:0011' => { engine: SQLSERVER_WEB, license: 'li' },
          'CreateDBInstance:0012' => { engine: SQLSERVER_SE, license: 'li' },
          'CreateDBInstance:0014' => { engine: POSTGRESQL, license: 'none' },
          'CreateDBInstance:0015' => { engine: SQLSERVER_EE, license: 'li' },
          'CreateDBInstance:0016' => { engine: AURORA, license: 'none' },
          'CreateDBInstance:0018' => { engine: MARIADB, license: 'none' },
          'CreateDBInstance:0019' => { engine: ORACLE_SE2, license: 'byol' },
          'CreateDBInstance:0020' => { engine: ORACLE_SE2, license: 'li' },
          'CreateDBInstance:0021' => { engine: AURORA_POSTGRESQL, license: 'none' },
          'CreateDBInstance:0100' => { engine: SQLSERVER_EE, license: 'byol' },
          'CreateDBInstance:0110' => { engine: MYSQL, license: 'none' },
          'CreateDBInstance:0120' => { engine: POSTGRESQL, license: 'none' },
          'CreateDBInstance:0402' => { engine: SQLSERVER_SE,  license: 'li' },
          'CreateDBInstance:0403' => { engine: SQLSERVER_EE,  license: 'li' },
        }

        def map_operation_to_engine(operation_code)
          OPERATION_MAP[operation_code]
        end
      end
    end
  end
end
